#version 330
#extension GL_ARB_separate_shader_objects : enable





layout(location = 0) in vec2 _vin_Position;
layout(location = 1) in vec4 _vin_Color;

struct SVertexInput
{
	vec2 Position;
	vec4 Color;
	int VertexIndex;
	uint InstanceId;
};

layout(location = 0) smooth out vec4 _vout_fragColor;

struct SVertexOutput
{
	vec4 fragColor;
	vec4 VertexPosition;
};


layout( std140) uniform UProfilerConstant
{
	mat4 Transform;
} ProfilerConstant;


mat4 GetMeshMatrix( in SVertexInput  vInput  )
{
	return  mat4(vec4(1, 0, 0, 0), vec4(0, 1, 0, 0), vec4(0, 0, 1, 0), vec4(0, 0, 0, 1)) ;

}



void VertexMain( in SVertexInput  vInput,  out SVertexOutput  vOutput  )
{
	vOutput.fragColor = vInput.Color;
	vOutput.VertexPosition =  (( ProfilerConstant.Transform ) * (vec4(vInput.Position.xy, 0.0, 1.0))) ;
}


void main()
{
	SVertexInput vInput;
	SVertexOutput vOutput;

	vInput.Position = _vin_Position;
	vInput.Color = _vin_Color;
	vInput.VertexIndex = gl_VertexID;
	vInput.InstanceId = uint(gl_InstanceID);
	vOutput.fragColor = vec4(0, 0, 0, 0);
	VertexMain(vInput, vOutput);
	_vout_fragColor = vOutput.fragColor;
	gl_Position = vOutput.VertexPosition;
}
